/**
*  Descripción General: Clase de prueba para Nuevas Provisiones de Incentivos
*  ________________________________________________________________
*      Autor                   Fecha               Descripción
*  ________________________________________________________________
*      Cecilia Cruz         31/Ago/2020      Versión Inicial
*	   Cecilia Cruz        03/Nov/2021       -Actualización de regla: Una VC de Fleet N no puede cerrar con RDR en meses anteriores.
*                                       	 -Actualización de regla: No exceder 90 días con la fecha de cierre de ventas calendario Toyota.
*  _______________________________________________________________
*/
@isTest(SeeAllData=false)
public class TAM_NewProvisionTestClass {
	
	@testSetup static void setup(){
		DateTime fechaVenta = DateTime.now();
        String month = String.valueOf(fechaVenta.month());
        String year = String.valueOf(fechaVenta.year());
		
		//User
        User usuarioGuadalajara = TAM_TestUtilityClass.crearUsuarioPartnerCommunity('Gerente Guadalajara', '57011');
		
		//Calendario Toyota
        TAM_CalendarioToyota__c objCalendario = new TAM_CalendarioToyota__c();
        objCalendario.Name = 'Calendario Prueba';
        objCalendario.TAM_Anio__c = String.valueOf(fechaVenta.year());
        objCalendario.TAM_FechaInicio__c = fechaVenta.date();
        objCalendario.TAM_FechaFin__c = fechaVenta.date();
        insert objCalendario;
		
		//Series
        Serie__c objSerie_RAV4 = TAM_TestUtilityClass.crearSerie('RAV4');
        Serie__c objSerie_AVANZA = TAM_TestUtilityClass.crearSerie('AVANZA');
        Serie__c objSerie_COROLLA = TAM_TestUtilityClass.crearSerie('COROLLA');
        
        //Productos
        Product2 objProducto_RAV4_45012020 = TAM_TestUtilityClass.crearProducto(objSerie_RAV4.Id, '4501', '2020', true);
        Product2 objProducto_RAV4_45022020 = TAM_TestUtilityClass.crearProducto(objSerie_RAV4.Id, '4502', '2020', true);
        Product2 objProducto_RAV4_45032020 = TAM_TestUtilityClass.crearProducto(objSerie_RAV4.Id, '4503', '2020', true);
        Product2 objProducto_AVANZA_22072020 = TAM_TestUtilityClass.crearProducto(objSerie_AVANZA.Id, '2207', '2020', true);
        Product2 objProducto_COROLLA_1780020 = TAM_TestUtilityClass.crearProducto(objSerie_COROLLA.Id, '1780', '2020', true);
        
        //Catálogo Centralizado
        CatalogoCentralizadoModelos__c objCatalogo_RAV4 = TAM_TestUtilityClass.crearModeloCatalogoCentralizado('RAV4', '4501','2020', 'x');
        CatalogoCentralizadoModelos__c objCatalogo_RAV4_2 = TAM_TestUtilityClass.crearModeloCatalogoCentralizado('RAV4', '4502','2020', 'x');
        CatalogoCentralizadoModelos__c objCatalogo_RAV4_3 = TAM_TestUtilityClass.crearModeloCatalogoCentralizado('RAV4', '4503','2020', 'x');
        CatalogoCentralizadoModelos__c objCatalogo_AVANZA = TAM_TestUtilityClass.crearModeloCatalogoCentralizado('AVANZA', '2207','2020', 'x');
        CatalogoCentralizadoModelos__c objCatalogo_COROLLA = TAM_TestUtilityClass.crearModeloCatalogoCentralizado('COROLLA', '1780','2020', 'x');
        
        //Pricebook2
        Id standardPricebookId = Test.getStandardPricebookId();
        
        Map<String, String> mapMesAUX = new Map<String, String>();
        mapMesAUX.put('1', 'Enero');
        mapMesAUX.put('2', 'Febrero');
        mapMesAUX.put('3', 'Marzo');
        mapMesAUX.put('4', 'Abril');
        mapMesAUX.put('5', 'Mayo');
        mapMesAUX.put('6', 'Junio');
        mapMesAUX.put('7', 'Julio');
        mapMesAUX.put('8', 'Agosto');
        mapMesAUX.put('9', 'Septiembre');
        mapMesAUX.put('10', 'Octubre');
        mapMesAUX.put('11', 'Noviembre');
        mapMesAUX.put('12', 'Diciembre');
        String strMonth = mapMesAUX.get(month);
        
        PriceBook2 customPriceBook = new PriceBook2();
        customPriceBook.Name='VH-' + strMonth + '-' + year;
        customPriceBook.Description = 'VH-' + strMonth + '-' + year;
        customPriceBook.IdExternoListaPrecios__c = 'VH-' + strMonth + '-' + year;
        customPriceBook.IsActive=true;
        insert customPriceBook;
        
        //PricebookEntry
        TAM_TestUtilityClass.crearPricebookEntryCustom(standardPricebookId, objProducto_RAV4_45012020, true, 400000, 10, 40000);
        TAM_TestUtilityClass.crearPricebookEntryCustom(standardPricebookId, objProducto_RAV4_45022020, true, 400000, 10, 40000);
        TAM_TestUtilityClass.crearPricebookEntryCustom(standardPricebookId, objProducto_RAV4_45032020, true, 400000, 10, 40000);
        TAM_TestUtilityClass.crearPricebookEntryCustom(standardPricebookId, objProducto_AVANZA_22072020, true, 200000, 10, 20000);
        TAM_TestUtilityClass.crearPricebookEntryCustom(standardPricebookId, objProducto_COROLLA_1780020, true, 300000, 10, 30000);
        
        TAM_TestUtilityClass.crearPricebookEntryCustom(customPriceBook.Id, objProducto_RAV4_45012020, true, 400000, 10, 40000);
        TAM_TestUtilityClass.crearPricebookEntryCustom(customPriceBook.Id, objProducto_RAV4_45022020, true, 400000, 10, 40000);
        TAM_TestUtilityClass.crearPricebookEntryCustom(customPriceBook.Id, objProducto_RAV4_45032020, true, 400000, 10, 40000);
        TAM_TestUtilityClass.crearPricebookEntryCustom(customPriceBook.Id, objProducto_AVANZA_22072020, true, 200000, 10, 20000);
        TAM_TestUtilityClass.crearPricebookEntryCustom(customPriceBook.Id, objProducto_COROLLA_1780020, true, 300000, 10, 30000);
		
		//Política de incentivos Venta Corporativa
        TAM_PoliticasIncentivos__c objPoliticaVtaCorp = TAM_TestUtilityClass.crearPoliticaIncentivos('Venta Corporativa', 'Politica_VtaCorp', Date.valueOf(fechaVenta)-1, Date.valueOf(fechaVenta)+1, true, 'Vigente');
		
        //Detalle Politica
		TAM_DetallePoliticaJunction__c objDetallePolitica_VtaCorp_01 = TAM_TestUtilityClass.crearDetallePoliticaIncentivos('RAV4', '4501','2020', 'x',10000, 5000, 5000,0,0,0,false, objPoliticaVtaCorp.Id,400000); 
        TAM_DetallePoliticaJunction__c objDetallePolitica_VtaCorp_02 = TAM_TestUtilityClass.crearDetallePoliticaIncentivos('AVANZA', '2207','2020', 'x',5000, 2500, 2500,0,0,0,false, objPoliticaVtaCorp.Id,200000);
        TAM_DetallePoliticaJunction__c objDetallePolitica_VtaCorp_03 = TAM_TestUtilityClass.crearDetallePoliticaIncentivos('COROLLA', '1780','2020', 'x',50000, 25000, 25000,0,0,0,false, objPoliticaVtaCorp.Id,300000); 
        
        //Política Incentivos Retail
        TAM_PoliticasIncentivos__c objPoliticaRetail = TAM_TestUtilityClass.crearPoliticaIncentivos('Retail', 'Politica_Retail', Date.valueOf(fechaVenta)-1, Date.valueOf(fechaVenta)+1, true, 'Vigente');
        
        //Detalle Política
        /*Escenario 1 "Incentivo Efectivo y Producto Financiero pero no aplican ambos"*/
        TAM_DetallePoliticaJunction__c objDetallePolitica_Retail_01 = TAM_TestUtilityClass.crearDetallePoliticaIncentivos('RAV4', '4501','2020', 'x',10000, 5000, 5000,10000, 5000, 5000,false, objPoliticaRetail.Id,400000);
        
        /*Escenario 2 "Incentivo Efectivo y Producto Financiero y aplican ambos"*/
        TAM_DetallePoliticaJunction__c objDetallePolitica_Retail_02 = TAM_TestUtilityClass.crearDetallePoliticaIncentivos('RAV4', '4502','2020', 'x',10000, 5000, 5000,10000, 5000, 5000,true, objPoliticaRetail.Id,400000);

        /*Escenario 3 "Incentivo Producto Financiero sin captura de Incentivo en Efectivo"*/
        TAM_DetallePoliticaJunction__c objDetallePolitica_Retail_03 = TAM_TestUtilityClass.crearDetallePoliticaIncentivos('RAV4', '4503','2020', 'x',0,0,0,10000, 5000, 5000,false, objPoliticaRetail.Id,400000);
        
        /*Escenario 4 "Incentivo Efectivo sin Producto Financiero"*/
        TAM_DetallePoliticaJunction__c objDetallePolitica_Retail_04 =TAM_TestUtilityClass.crearDetallePoliticaIncentivos('AVANZA', '2207','2020', 'x',5000, 2500, 2500,0,0,0,false, objPoliticaRetail.Id,200000);        
        
        //Politica Incentivo Bonos
        TAM_Bonos__c objPoliticaBono = TAM_TestUtilityClass.crearPoliticaBonos('Politica_Bono', Date.valueOf(fechaVenta)-1, Date.valueOf(fechaVenta)+1);
        
        //Detalle Incentivo Bonos
        TAM_DetalleBonos__c objDetalleBono_01 = TAM_TestUtilityClass.crearDetalleBono(objPoliticaBono.Id, '2020', '4501', 'RAV4',10000, 5000, 5000, 0,12000, 3000, 3000, 6000,false);
        TAM_DetalleBonos__c objDetalleBono_02 = TAM_TestUtilityClass.crearDetalleBono(objPoliticaBono.Id, '2020', '1780', 'COROLLA',10000, 5000, 5000, 0,12000, 3000, 3000, 6000,false);
        TAM_DetalleBonos__c objDetalleBono_03 = TAM_TestUtilityClass.crearDetalleBono(objPoliticaBono.Id, '2019', '1780', 'COROLLA',0, 0, 0, 0,0, 0, 0, 0,false);
        
		/****************************************** | PROVISIÓN INCENTIVOS	| ******************************************/
        Map<Integer, String> mapMes = new Map<Integer, String>();
        mapMes.put(1, 'Enero');
        mapMes.put(2, 'Febrero');
        mapMes.put(3, 'Marzo');
        mapMes.put(4, 'Abril');
        mapMes.put(5, 'Mayo');
        mapMes.put(6, 'Junio');
        mapMes.put(7, 'Julio');
        mapMes.put(8, 'Agosto');
        mapMes.put(9, 'Septiembre');
        mapMes.put(10,'Octubre');
        mapMes.put(11,'Noviembre');
        mapMes.put(12,'Diciembre');
        
        String strMesProvision = mapMes.get(Date.today().month());
        String strAnioProvision = String.valueOf(Date.today().year());
        
        TAM_ProvisionIncentivos__c objProvision = new TAM_ProvisionIncentivos__c();
        objProvision.Name = 'Provision Prueba';
        objProvision.TAM_MesDeProvision__c = strMesProvision;
        objProvision.TAM_AnioDeProvision__c = strAnioProvision;
        insert objProvision;
        
         /*PROVISIÓN INCENTIVOS Anterior*/
        Integer mes = Date.today().month();
        String strMesProvisionAnterior = mapMes.get(mes -1);
        String strAnioProvisionAnterior = String.valueOf(Date.today().year());
        
        TAM_ProvisionIncentivos__c objProvisionAnterior = new TAM_ProvisionIncentivos__c();
        objProvisionAnterior.Name = 'Provision Prueba Anterior';
        objProvisionAnterior.TAM_MesDeProvision__c = strMesProvisionAnterior;
        objProvisionAnterior.TAM_AnioDeProvision__c = strAnioProvisionAnterior;
        insert objProvisionAnterior;
	}
	
	//Prueba Retail Sin Reversa
	@isTest
    public static void provisionBatchRetail_RetailSinReversa(){
		Test.startTest();
		DateTime fechaVenta = DateTime.now();
        String month = String.valueOf(fechaVenta.month());
        String year = String.valueOf(fechaVenta.year());
        List<Vehiculo__c> lstVehiculo = new List<Vehiculo__c>();
        List<Movimiento__c> lstMovimientos = new List<Movimiento__c>();
        User usuarioGuadalajara = [SELECT Id,CodigoDistribuidor__c FROM User WHERE CodigoDistribuidor__c = '57011' LIMIT 1];
        TAM_ProvisionIncentivos__c objProvision = [SELECT Id FROM TAM_ProvisionIncentivos__c WHERE Name = 'Provision Prueba' LIMIT 1];
        Account acc = [SELECT Id FROM Account WHERE Name='Gerente Guadalajara' LIMIT 1];
		
		//Productos
        Product2 objProducto_RAV4_45012020 = [SELECT Id FROM Product2 WHERE Name= '4501' LIMIT 1];
        Product2 objProducto_RAV4_45022020 = [SELECT Id FROM Product2 WHERE Name= '4502' LIMIT 1];
        Product2 objProducto_RAV4_45032020 = [SELECT Id FROM Product2 WHERE Name= '4503' LIMIT 1];
		Product2 objProducto_AVANZA_22072020 = [SELECT Id FROM Product2 WHERE Name= '2207' LIMIT 1];
		
		//Politica Incentivos Retail
        TAM_PoliticasIncentivos__c objPoliticaRetail = [SELECT Id FROM TAM_PoliticasIncentivos__c WHERE Name='Politica_Retail'];
        TAM_DetallePoliticaJunction__c objDetallePolitica_Retail_01 = [SELECT id FROM TAM_DetallePoliticaJunction__c WHERE TAM_Clave__c='4501' LIMIT 1]; 
        TAM_DetallePoliticaJunction__c objDetallePolitica_Retail_02 = [SELECT id FROM TAM_DetallePoliticaJunction__c WHERE TAM_Clave__c='4502' LIMIT 1]; 
        TAM_DetallePoliticaJunction__c objDetallePolitica_Retail_03 = [SELECT id FROM TAM_DetallePoliticaJunction__c WHERE TAM_Clave__c='4503' LIMIT 1]; 
        TAM_DetallePoliticaJunction__c objDetallePolitica_Retail_04 = [SELECT id FROM TAM_DetallePoliticaJunction__c WHERE TAM_Clave__c='2207' LIMIT 1]; 
		
		//Vehiculos
        /*Prueba Escenario 1*/	Vehiculo__c objVehiculoRetail_1 = TAM_TestUtilityClass.crearVIN('JTDKDTB33M1143181', '2020');
        						lstVehiculo.add(objVehiculoRetail_1);
        /*Prueba Escenario 2*/	Vehiculo__c objVehiculoRetail_2 = TAM_TestUtilityClass.crearVIN('JTDKDTB38M1142682', '2020');
        						lstVehiculo.add(objVehiculoRetail_2);
        /*Prueba Escenario 3*/	Vehiculo__c objVehiculoRetail_3 = TAM_TestUtilityClass.crearVIN('JTDKDTB38M1142683', '2020');
        						lstVehiculo.add(objVehiculoRetail_3);
        /*Prueba Escenario 4*/	Vehiculo__c objVehiculoRetail_4 = TAM_TestUtilityClass.crearVIN('JTDKDTB38M1142684', '2020');
        						lstVehiculo.add(objVehiculoRetail_4);
        
		Database.insert(lstVehiculo);
        lstVehiculo.clear();
		
		/*Escenario 1*/
        Movimiento__c objMovimientoRetail_1 = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '3', fechaVenta, 'N',month, year, objProducto_RAV4_45012020.Id, objVehiculoRetail_1.Id, acc.Id);
        lstMovimientos.add(objMovimientoRetail_1);
        
        /*Escenario 2*/
        Movimiento__c objMovimientoRetail_2 = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '3', fechaVenta, 'N',month, year, objProducto_RAV4_45022020.Id, objVehiculoRetail_2.Id, acc.Id);
        lstMovimientos.add(objMovimientoRetail_2);
        
        /*Escenario 3*/
        Movimiento__c objMovimientoRetail_3 = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '3', fechaVenta, 'N',month, year, objProducto_RAV4_45032020.Id, objVehiculoRetail_3.Id, acc.Id);
        lstMovimientos.add(objMovimientoRetail_3);
        
        /*Escenario 4*/
        Movimiento__c objMovimientoRetail_4 = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '3', fechaVenta, 'N',month, year, objProducto_AVANZA_22072020.Id, objVehiculoRetail_4.Id, acc.Id);
        lstMovimientos.add(objMovimientoRetail_4);
        
        Database.insert(lstMovimientos);
        
        //Último movimiento
        /*VIN Escenario 1*/	objVehiculoRetail_1.Ultimo_Movimiento__c = objMovimientoRetail_1.Id;
        					lstVehiculo.add(objVehiculoRetail_1);
        /*VIN Escenario 2*/	objVehiculoRetail_2.Ultimo_Movimiento__c = objMovimientoRetail_2.Id;
        					lstVehiculo.add(objVehiculoRetail_2);
        /*VIN Escenario 3*/	objVehiculoRetail_3.Ultimo_Movimiento__c = objMovimientoRetail_3.Id;
        					lstVehiculo.add(objVehiculoRetail_3);
        /*VIN Escenario 4*/	objVehiculoRetail_4.Ultimo_Movimiento__c = objMovimientoRetail_4.Id;
        					lstVehiculo.add(objVehiculoRetail_4);
        Database.update(lstVehiculo);
        
        //Proceso Batch     
		Id jobID = TAM_NewProvisionControllerClass.executeBatchJob(objProvision.Id);
        AsyncApexJob jobInfo = TAM_NewProvisionControllerClass.getBatchJobStatus(jobID);
		Test.stopTest();
	}
	
	//Prueba Venta Corporativa Sin Reversa
	@isTest
    public static void provisionVentaCorporativa(){
        Test.startTest();
        DateTime fechaVenta = DateTime.now();
        String month = String.valueOf(fechaVenta.month());
        String year = String.valueOf(fechaVenta.year());
        DateTime fechaVenta2 = fechaVenta.addMonths(-1);
        String month2 = String.valueOf(fechaVenta2.month());
        String year2 = String.valueOf(fechaVenta2.year());
        DateTime fechaVenta3 = fechaVenta.addDays(-100);
        String month3 = String.valueOf(fechaVenta2.month());
        String year3 = String.valueOf(fechaVenta2.year());
        DateTime fechaVenta4 = fechaVenta.addMonths(-2);
        String month4 = String.valueOf(fechaVenta2.month());
        String year4 = String.valueOf(fechaVenta2.year());
        List<Vehiculo__c> lstVehiculo = new List<Vehiculo__c>();
        List<Movimiento__c> lstMovimientos = new List<Movimiento__c>();
        User usuarioGuadalajara = [SELECT Id,CodigoDistribuidor__c FROM User WHERE CodigoDistribuidor__c = '57011' LIMIT 1];
        TAM_ProvisionIncentivos__c objProvision = [SELECT Id FROM TAM_ProvisionIncentivos__c WHERE Name = 'Provision Prueba' LIMIT 1];
        
        //Productos
        Product2 objProducto_COROLLA_1780020 = [SELECT Id FROM Product2 WHERE Name= '1780' LIMIT 1];
        
        //Política de incentivos
        TAM_PoliticasIncentivos__c objPoliticaVtaCorp = [SELECT Id FROM TAM_PoliticasIncentivos__c WHERE Name='Politica_VtaCorp'];
        //Detalle Politica
		TAM_DetallePoliticaJunction__c objDetallePolitica_VtaCorp_01 = TAM_TestUtilityClass.crearDetallePoliticaIncentivos('RAV4', '4501','2020', 'x',10000, 5000, 5000,0,0,0,false, objPoliticaVtaCorp.Id,400000); 
        TAM_DetallePoliticaJunction__c objDetallePolitica_VtaCorp_02 = TAM_TestUtilityClass.crearDetallePoliticaIncentivos('AVANZA', '2207','2020', 'x',5000, 2500, 2500, 0,0,0,false,objPoliticaVtaCorp.Id,200000);
        TAM_DetallePoliticaJunction__c objDetallePolitica_VtaCorp_03 = TAM_TestUtilityClass.crearDetallePoliticaIncentivos('COROLLA', '1780','2020', 'x',50000, 25000, 25000,0,0,0,false, objPoliticaVtaCorp.Id,300000); 
        
        Product2 objProducto_RAV4_45012020 = [SELECT Id FROM Product2 WHERE ProductCode='45012020'];
        Account acc = [SELECT Id FROM Account WHERE Name='Gerente Guadalajara' LIMIT 1];
        
        //Vehículos
        /*Estado de Cuenta*/	Vehiculo__c objVehiculoVtaCorp_00 = TAM_TestUtilityClass.crearVIN('VTMR13FV1LD061000', '2020');
        						lstVehiculo.add(objVehiculoVtaCorp_00);
        /*Pedido Especial*/		Vehiculo__c objVehiculoVtaCorp_1 = TAM_TestUtilityClass.crearVIN('VTMR13FV1LD061620', '2020');
        						lstVehiculo.add(objVehiculoVtaCorp_1);
        /*Reversa*/	        	Vehiculo__c objVehiculoVentaCorp_2 = TAM_TestUtilityClass.crearVIN('VTMR13FV1LD061621', '2020');
        						lstVehiculo.add(objVehiculoVentaCorp_2);
        /*Inventario*/			Vehiculo__c objVehiculoVentaCorp_inventario = TAM_TestUtilityClass.crearVIN('CTMR13FV1LD061620', '2020');
        						lstVehiculo.add(objVehiculoVentaCorp_inventario);
        /*Auto Demo*/			Vehiculo__c objVehiculoDemo_1 = TAM_TestUtilityClass.crearVIN('ATMR13FV1LD061622', '2020');
        						lstVehiculo.add(objVehiculoDemo_1);
        /*PE > 90 dias*/		Vehiculo__c objVehiculoVentaCorp_PE = TAM_TestUtilityClass.crearVIN('PEMR13FV1LD061690', '2020');
        						lstVehiculo.add(objVehiculoVentaCorp_PE);
        /*Inventario RDR*/		Vehiculo__c objVehiculoVentaCorpInventarioRDR = TAM_TestUtilityClass.crearVIN('RDRR13FV1LD061690', '2020');
        						lstVehiculo.add(objVehiculoVentaCorpInventarioRDR);
        
		Database.insert(lstVehiculo);
        lstVehiculo.clear();

        //Movimientos
        Movimiento__c objMovimiento1 = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '4', fechaVenta, 'N',month, year, objProducto_RAV4_45012020.id, objVehiculoVtaCorp_1.Id, acc.id);
        Movimiento__c objMovimiento2 = TAM_TestUtilityClass.crearMovimientos('2020','RVRSL', '4', fechaVenta, 'N',month, year, objProducto_RAV4_45012020.id, objVehiculoVentaCorp_2.Id, acc.id);
        Movimiento__c objMovimientoInventario1 = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '4', fechaVenta2, 'N',month2, year2, objProducto_COROLLA_1780020.Id, objVehiculoVentaCorp_inventario.Id, acc.Id);
        Movimiento__c objMovimientoInventario2 = TAM_TestUtilityClass.crearMovimientos('2020','RVRSL', '4', fechaVenta2, 'N',month2, year2, objProducto_COROLLA_1780020.Id, objVehiculoVentaCorp_inventario.Id, acc.Id);        
        Movimiento__c objMovimientoInventario3 = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '4', fechaVenta2, 'N',month2, year2, objProducto_COROLLA_1780020.Id, objVehiculoVentaCorp_inventario.Id, acc.Id);
        Movimiento__c objMovimientoDemo = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '1', fechaVenta, 'C',month, year, objProducto_COROLLA_1780020.Id, objVehiculoDemo_1.Id, acc.Id);
        Movimiento__c objMovimientoPE = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '1', fechaVenta3, 'C',month3, year3, objProducto_COROLLA_1780020.Id, objVehiculoDemo_1.Id, acc.Id);
        Movimiento__c objMovimientoInventarioRDR1 = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '1', fechaVenta4, 'N',month4, year4, objProducto_COROLLA_1780020.Id, objVehiculoVentaCorpInventarioRDR.Id, acc.Id);
        Movimiento__c objMovimientoInventarioRDR2 = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '1', fechaVenta2, 'N',month2, year2, objProducto_COROLLA_1780020.Id, objVehiculoVentaCorpInventarioRDR.Id, acc.Id);
        Movimiento__c objMovimientoInventarioRDR3 = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '1', fechaVenta, 'N',month, year, objProducto_COROLLA_1780020.Id, objVehiculoVentaCorpInventarioRDR.Id, acc.Id);
        lstMovimientos.add(objMovimiento1);
        lstMovimientos.add(objMovimiento2);
        lstMovimientos.add(objMovimientoInventario1);
        lstMovimientos.add(objMovimientoInventario2);
        lstMovimientos.add(objMovimientoInventario3);
        lstMovimientos.add(objMovimientoDemo);
        lstMovimientos.add(objMovimientoPE);
        lstMovimientos.add(objMovimientoInventarioRDR1);
        lstMovimientos.add(objMovimientoInventarioRDR2);
        lstMovimientos.add(objMovimientoInventarioRDR3);
        Database.insert(lstMovimientos);
        
        //Último movimiento
        objVehiculoVtaCorp_1.Ultimo_Movimiento__c = objMovimiento1.Id;
        lstVehiculo.add(objVehiculoVtaCorp_1);
        objVehiculoVentaCorp_2.Ultimo_Movimiento__c = objMovimiento2.Id;
        lstVehiculo.add(objVehiculoVentaCorp_2);
		objVehiculoVentaCorp_inventario.Ultimo_Movimiento__c = objMovimientoInventario3.Id;
		lstVehiculo.add(objVehiculoVentaCorp_inventario);
        objVehiculoDemo_1.Ultimo_Movimiento__c = objMovimientoDemo.Id;
		lstVehiculo.add(objVehiculoDemo_1);
        objVehiculoVentaCorp_PE.Ultimo_Movimiento__c  = objMovimientoPE.Id;
        lstVehiculo.add(objVehiculoVentaCorp_PE);
        objVehiculoVentaCorpInventarioRDR.Ultimo_Movimiento__c = objMovimientoInventarioRDR3.Id;
        lstVehiculo.add(objVehiculoVentaCorpInventarioRDR);
        
        Database.update(lstVehiculo);
        
        //Cliente Corporativo
        Id RecordTypeId_ClienteCorp = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente Corporativo').getRecordTypeId();
        Account objClienteCorp =  new Account(Name = 'ELEMENT FLEET MANAGEMENT CORPORATION MEXICO SA DE CV',
                                              recordTypeId = RecordTypeId_ClienteCorp);
        //Rango
        Rangos__c objRangoB = TAM_TestUtilityClass.crearRango('Rango B', 1, 30, true, 'Flotillas');
        
        //Solicitud de Flotilla/Programa
        TAM_SolicitudesFlotillaPrograma__c objSolicitudFlotilla = TAM_TestUtilityClass.crearSolicitudFlotilla(objClienteCorp.Id, objRangoB.Id, usuarioGuadalajara.CodigoDistribuidor__c, 'Cerrada','Venta Corporativa');
        TAM_SolicitudesFlotillaPrograma__c objSolicitudFlotillaName = [SELECT Name FROM TAM_SolicitudesFlotillaPrograma__c WHERE Id=:objSolicitudFlotilla.Id LIMIT 1];
         
        //Catalogo Centralizado de modelos
        CatalogoCentralizadoModelos__c objCatalogo_COROLLA = [SELECT Id FROM CatalogoCentralizadoModelos__c WHERE Serie__c = 'COROLLA' LIMIT 1];
        
        //Detalle Orden Compra
        TAM_DetalleOrdenCompra__c objDetalleOrdenCompra_Inventario = TAM_TestUtilityClass.crearDetalleCompra(objSolicitudFlotillaName.Name, Date.valueOf(fechaVenta), 'Entregado', objSolicitudFlotilla.Id, objCatalogo_COROLLA.Id, 'Inventario');
        TAM_DetalleOrdenCompra__c objDetalleOrdenCompra_Pedido = TAM_TestUtilityClass.crearDetalleCompra(objSolicitudFlotillaName.Name, Date.valueOf(fechaVenta), 'Entregado', objSolicitudFlotilla.Id, objCatalogo_COROLLA.Id, 'Pedido Especial');
        
        //Vin orden compra
        TAM_TestUtilityClass.crearVinFlotilla(objVehiculoVentaCorp_inventario.Name, objSolicitudFlotilla.Id, 'Flotilla', objDetalleOrdenCompra_Inventario.Name, 'Cerrada');
        TAM_TestUtilityClass.crearVinFlotilla('00000000000000000', objSolicitudFlotilla.Id, 'Flotilla', objDetalleOrdenCompra_Pedido.Name, 'Cerrada');
       
        //Checkout Flotillas/Programas
        /*Inventario*/
        String sRectorTypeInventario = Schema.SObjectType.TAM_DetalleOrdenCompra__c.getRecordTypeInfosByName().get('Inventario').getRecordTypeId();
        TAM_CheckOutDetalleSolicitudCompra__c objCheckOut_Inventario = new TAM_CheckOutDetalleSolicitudCompra__c(
            TAM_VIN__c = objVehiculoVentaCorp_inventario.Name,
            Name = objSolicitudFlotillaName.Name,
            TAM_IdExterno__c = objSolicitudFlotilla.id + '-' + '2020-COROLLA-1780-x-10' + '-' + sRectorTypeInventario,
            TAM_TipoPago__c = 'Arrendadora',
            TAM_TipoVenta__c = 'Inventario',
            TAM_EntregadoDealer__c = true,
            TAM_EstatusEntrega__c = 'Entregado',
            TAM_EstatusDealerSolicitud__c = 'Autorizada',
            TAM_SolicitudFlotillaPrograma__c = objSolicitudFlotilla.id,
            TAM_CatalogoCentralizadoModelos__c = objCatalogo_COROLLA.id,
            TAM_IncPropuestoCash__c = 10000,
            TAM_IncentivoTMEXCash__c = 5000,
            TAM_PoliticaIncentivos__c = objPoliticaVtaCorp.Id,
            TAM_IncPropuestoPorcentaje__c = 0
        );
        insert objCheckOut_Inventario;
        
        /*Inventario con RDR en meses anteriores*/
        String sRectorTypeInventario2 = Schema.SObjectType.TAM_DetalleOrdenCompra__c.getRecordTypeInfosByName().get('Inventario').getRecordTypeId();
        TAM_CheckOutDetalleSolicitudCompra__c objCheckOut_Inventario2 = new TAM_CheckOutDetalleSolicitudCompra__c(
            TAM_VIN__c = objVehiculoVentaCorpInventarioRDR.Name,
            Name = objSolicitudFlotillaName.Name,
            TAM_IdExterno__c = objSolicitudFlotilla.id + '-' + '2020-COROLLA-1780-x-20' + '-' + sRectorTypeInventario2,
            TAM_TipoPago__c = 'Arrendadora',
            TAM_TipoVenta__c = 'Inventario',
            TAM_EntregadoDealer__c = true,
            TAM_EstatusEntrega__c = 'Entregado',
            TAM_EstatusDealerSolicitud__c = 'Autorizada',
            TAM_SolicitudFlotillaPrograma__c = objSolicitudFlotilla.id,
            TAM_CatalogoCentralizadoModelos__c = objCatalogo_COROLLA.id,
            TAM_IncPropuestoCash__c = 10000,
            TAM_IncentivoTMEXCash__c = 5000,
            TAM_PoliticaIncentivos__c = objPoliticaVtaCorp.Id,
            TAM_IncPropuestoPorcentaje__c = 0
        );
        insert objCheckOut_Inventario2;
        
        /*Pedido Especial*/
        String sRectorTypePasoPedidoEspecial = Schema.SObjectType.TAM_DetalleOrdenCompra__c.getRecordTypeInfosByName().get('Pedido Especial').getRecordTypeId();
        TAM_CheckOutDetalleSolicitudCompra__c objCheckOutDetSolComp = new TAM_CheckOutDetalleSolicitudCompra__c(
            TAM_VIN__c = objVehiculoVtaCorp_1.Name,
            Name = objSolicitudFlotillaName.Name,
            TAM_IdExterno__c = objSolicitudFlotilla.id + '-' + '2020-COROLLA-1780-x-10' + '-' + sRectorTypePasoPedidoEspecial,
            TAM_TipoPago__c = 'Arrendadora',
            TAM_TipoVenta__c = 'Pedido Especial',
            TAM_EntregadoDealer__c = true,
            TAM_EstatusEntrega__c = 'Entregado',
            TAM_SolicitudFlotillaPrograma__c = objSolicitudFlotilla.id,
            TAM_CatalogoCentralizadoModelos__c = objCatalogo_COROLLA.id,
            TAM_IncPropuestoPorcentaje__c = 10,
            TAM_IncentivoTMEXPorcentaje__c = 5,
            TAM_PoliticaIncentivos__c = objPoliticaVtaCorp.Id
        );
        insert objCheckOutDetSolComp;
        
        /*Pedido Especial DD mayor a 90*/
        String sRectorTypePasoPedidoEspecial2 = Schema.SObjectType.TAM_DetalleOrdenCompra__c.getRecordTypeInfosByName().get('Pedido Especial').getRecordTypeId();
        TAM_CheckOutDetalleSolicitudCompra__c objCheckOutDetSolComp2 = new TAM_CheckOutDetalleSolicitudCompra__c(
            TAM_VIN__c = objVehiculoVentaCorp_PE.Name,
            Name = objSolicitudFlotillaName.Name,
            TAM_IdExterno__c = objSolicitudFlotilla.id + '-' + '2020-COROLLA-1780-x-90' + '-' + sRectorTypePasoPedidoEspecial2,
            TAM_TipoPago__c = 'Arrendadora',
            TAM_TipoVenta__c = 'Pedido Especial',
            TAM_EntregadoDealer__c = true,
            TAM_EstatusEntrega__c = 'Entregado',
            TAM_SolicitudFlotillaPrograma__c = objSolicitudFlotilla.id,
            TAM_CatalogoCentralizadoModelos__c = objCatalogo_COROLLA.id,
            TAM_IncPropuestoPorcentaje__c = 10,
            TAM_IncentivoTMEXPorcentaje__c = 5,
            TAM_PoliticaIncentivos__c = objPoliticaVtaCorp.Id
        );
        insert objCheckOutDetSolComp2;
        
        //DOD pedido especial
        TAM_DODSolicitudesPedidoEspecial__c DODSolPedidoEspecial = new TAM_DODSolicitudesPedidoEspecial__c(
            Name = objSolicitudFlotillaName.Name,
            TAM_SolicitudFlotillaPrograma__c = objSolicitudFlotilla.id,
            TAM_CatalogoCentralizadoModelos__c = objCatalogo_COROLLA.id, 
            TAM_VINDistribuidor__c = objVehiculoVtaCorp_1.Name,
            TAM_Entrega__c = '570550-TOYOTA POLANCO',
            TAM_VIN__c = objVehiculoVtaCorp_1.Name,
            TAM_FechaHoraRecibo__c = Date.today(),
            TAM_EntregadoDealer__c = true,
            TAM_Estatus__c = 'Asignado',
            TAM_IncentivoTMEXPorcentaje__c = 2.1,
            TAM_IncPropuestoCash__c = 0,
            TAM_IncentivoTMEXCash__c = 0,
            TAM_DescuentoAutorizadoDTM__c = 4.2
        );
        insert DODSolPedidoEspecial;
        
        //Solicitud Excepcion Venta Corporativa
        TAM_PoliticasIncentivos__c objPoliticaRetail = [SELECT Id FROM TAM_PoliticasIncentivos__c WHERE Name='Politica_Retail'];
        String vtaCorp = objPoliticaRetail.Id;
        //TAM_DetallePoliticaJunction__c objDetalleCorp = [SELECT Id FROM TAM_DetallePoliticaJunction__c WHERE TAM_Serie__c = 'COROLLA' AND TAM_PoliticaIncentivos__c =:vtaCorp  LIMIT 1];
        TAM_TestUtilityClass.solicitudExcepcionIncentivo('Excepción de Venta Corporativa',objVehiculoVentaCorp_2.Name, objDetallePolitica_VtaCorp_03.Id, 'Aprobado', Date.valueOf(fechaVenta).addMonths(-1));
        
        //Estado de Cuenta - Venta Corporativa
        TAM_TestUtilityClass.crearDetalleEdoCuenta(objVehiculoVentaCorp_2.Name, Date.valueOf(fechaVenta)-10, usuarioGuadalajara.CodigoDistribuidor__c, 20000, 'Flotilla','Pago Autorizado TMEX','Enviado a Facturar', 'Incentivos',false);
        TAM_DetalleEstadoCuenta__c objDetalle = [SELECT Id,TAM_Movimiento__c,TAM_Estatus_Finanzas__c,TAM_IntercambioEdoCta__c FROM TAM_DetalleEstadoCuenta__c WHERE TAM_VIN__c =:objVehiculoVentaCorp_2.Name LIMIT 1];
        objDetalle.TAM_Movimiento__c = 'Excepción';
        objDetalle.TAM_Estatus_Finanzas__c = 'Pago Autorizado TMEX';
        update objDetalle;
        
        /****************************************** AUTO DEMO ******************************************/
        //Modulo Auto Demo
        SolicitudAutoDemo__c objDemoMod = new SolicitudAutoDemo__c();
        objDemoMod.VIN__c = objVehiculoDemo_1.Id;
        objDemoMod.Estatus__c = 'Autorización alta TMEX';
        insert objDemoMod;
        
        //Solicitud Auto Demo
        TAM_TestUtilityClass.crearDetalleEdoCuenta(objVehiculoDemo_1.Name, Date.valueOf(fechaVenta), usuarioGuadalajara.CodigoDistribuidor__c, 20000, 'AutoDemo','Pago Autorizado TMEX','Enviado a Facturar','Incentivos', false);        
        
        /****************************************** ESTADO DE CUENTA ******************************************/
        TAM_TestUtilityClass.crearDetalleEdoCuenta(objVehiculoVtaCorp_00.Name, Date.valueOf(fechaVenta)-10, usuarioGuadalajara.CodigoDistribuidor__c, 20000, 'Flotilla','Pago Autorizado TMEX','Enviado a Facturar', 'RVRSL',false);        
        
        Id jobID_VtaCorp = TAM_NewProvisionControllerClass.executeBatchJob_VtaCorp(objProvision.Id);
        AsyncApexJob jobInfo_VtaCorp = TAM_NewProvisionControllerClass.getBatchJobStatus_VtaCorp(jobID_VtaCorp);
        Test.stopTest();
        System.assertEquals(0, jobInfo_VtaCorp.NumberOfErrors);
    }
    
	//Prueba Auto Demo
	@isTest
    public static void provisionBatchRetail_Demos(){
        Test.startTest();
        DateTime fechaVenta = DateTime.now();
        String month = String.valueOf(fechaVenta.month());
        String year = String.valueOf(fechaVenta.year());
        User usuarioGuadalajara = [SELECT Id,CodigoDistribuidor__c FROM User WHERE CodigoDistribuidor__c = '57011' LIMIT 1];
        TAM_ProvisionIncentivos__c objProvision = [SELECT Id FROM TAM_ProvisionIncentivos__c WHERE Name = 'Provision Prueba' LIMIT 1];
        Account acc = [SELECT Id FROM Account WHERE Name='Gerente Guadalajara' LIMIT 1];
        
		//Productos
        Product2 objProducto_AVANZA_22072020 = [SELECT Id FROM Product2 WHERE Name= '2207' LIMIT 1];
        
        //Politica Incentivos Retail
        TAM_PoliticasIncentivos__c objPoliticaRetail = [SELECT Id FROM TAM_PoliticasIncentivos__c WHERE Name='Politica_Retail'];
        TAM_DetallePoliticaJunction__c objDetallePolitica_Retail_04 = [SELECT id FROM TAM_DetallePoliticaJunction__c WHERE TAM_Clave__c='2207' LIMIT 1]; 

		//Vehiculos Auto Demo
        Vehiculo__c objVehiculoDemo_1 = TAM_TestUtilityClass.crearVIN('ATMR13FV1LD061622', '2020');
        Database.insert(objVehiculoDemo_1);
        
        //Movimientos Auto Demo
        Movimiento__c objMovimiento = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '1', fechaVenta, 'N',month, year, objProducto_AVANZA_22072020.Id, objVehiculoDemo_1.Id, acc.Id);
        Database.insert(objMovimiento);
        objVehiculoDemo_1.Ultimo_Movimiento__c = objMovimiento.Id;
        Database.update(objVehiculoDemo_1);
        
        //Modulo Auto Demo
        SolicitudAutoDemo__c objDemoMod = new SolicitudAutoDemo__c();
        objDemoMod.VIN__c = objVehiculoDemo_1.Id;
        objDemoMod.Estatus__c = 'Autorización alta TMEX';
        insert objDemoMod;
        
        //Solicitud Auto Demo
        TAM_TestUtilityClass.crearDetalleEdoCuenta(objVehiculoDemo_1.Name, Date.valueOf(fechaVenta), usuarioGuadalajara.CodigoDistribuidor__c, 20000, 'AutoDemo','Pago Autorizado TMEX','Enviado a Facturar','RDR', false);        
        
        //Proceso Batch        
		Id jobID = TAM_NewProvisionControllerClass.executeBatchJob(objProvision.Id);
        AsyncApexJob jobInfo = TAM_NewProvisionControllerClass.getBatchJobStatus(jobID);
        Test.stopTest();
        System.assertEquals(0, jobInfo.NumberOfErrors);
    }
    
	//Prueba Bono sin reversa
	@isTest
    public static void provisionBono(){
        //Obtener Datos
        Test.startTest();
        List<Vehiculo__c> lstVehiculo = new List<Vehiculo__c>();
        List<Movimiento__c> lstMovimientos = new List<Movimiento__c>();
        User usuarioGuadalajara = [SELECT Id,CodigoDistribuidor__c FROM User WHERE CodigoDistribuidor__c = '57011' LIMIT 1];
        TAM_ProvisionIncentivos__c objProvision = [SELECT Id FROM TAM_ProvisionIncentivos__c WHERE Name = 'Provision Prueba' LIMIT 1];
        TAM_ProvisionIncentivos__c objProvisionAnterior = [SELECT Id FROM TAM_ProvisionIncentivos__c WHERE Name = 'Provision Prueba Anterior' LIMIT 1];
        Account acc = [SELECT Id FROM Account WHERE Name='Gerente Guadalajara' LIMIT 1];
        
        DateTime fechaVenta = DateTime.now();
        DateTime fechaVenta2 = DateTime.now().addDays(-70);
        String month = String.valueOf(fechaVenta.month());
        String year = String.valueOf(fechaVenta.year());
        String month2 = String.valueOf(fechaVenta2.month());
        String year2 = String.valueOf(fechaVenta2.year());
        
        //Productos
        Product2 objProducto_COROLLA_1780020 = [SELECT Id FROM Product2 WHERE Name= '1780' LIMIT 1];
        
        //Politica Incentivos
        TAM_PoliticasIncentivos__c objPoliticaRetail = [SELECT Id FROM TAM_PoliticasIncentivos__c WHERE Name='Politica_Retail'];
        TAM_Bonos__c objPoliticaBono =[SELECT Id FROM TAM_Bonos__c WHERE Name='Politica_Bono']; 
        
        //Vehiculos
        /*RDR*/				Vehiculo__c objVehiculoBono_1 = TAM_TestUtilityClass.crearVIN('BONODTB38M1142681', '2020');
        					lstVehiculo.add(objVehiculoBono_1);
        /*RVRSL*/			Vehiculo__c objVehiculoBono_RVRSL = TAM_TestUtilityClass.crearVIN('BONODTB38M1142600', '2020');
        					lstVehiculo.add(objVehiculoBono_RVRSL);
        /*Vin en Edo Cta*/	Vehiculo__c objVehiculoRetail_1 = TAM_TestUtilityClass.crearVIN('JTDKDTB38M1142681', '2020');
        					lstVehiculo.add(objVehiculoRetail_1);
        Database.insert(lstVehiculo);
        lstVehiculo.clear();
        
        //Movimientos
        Movimiento__c objMovimientoRetail_1 = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '1', fechaVenta, 'N',month, year, objProducto_COROLLA_1780020.Id, objVehiculoRetail_1.Id, acc.Id);
        Movimiento__c objMovimientoBono_1 = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '1', fechaVenta, 'N',month, year, objProducto_COROLLA_1780020.Id, objVehiculoBono_1.Id, acc.Id);
        Movimiento__c objMovimientoBono_RVRSL = TAM_TestUtilityClass.crearMovimientos('2020','RVRSL', '1', fechaVenta, 'N',month, year, objProducto_COROLLA_1780020.Id, objVehiculoBono_RVRSL.Id, acc.Id);
        lstMovimientos.add(objMovimientoRetail_1);
        lstMovimientos.add(objMovimientoBono_1);
        lstMovimientos.add(objMovimientoBono_RVRSL);
        Database.insert(lstMovimientos);
        
        //Último movimiento
        objVehiculoRetail_1.Ultimo_Movimiento__c = objMovimientoRetail_1.Id;
        lstVehiculo.add(objVehiculoRetail_1);
        objVehiculoBono_1.Ultimo_Movimiento__c = objMovimientoBono_1.Id;
        lstVehiculo.add(objVehiculoBono_1);
        objVehiculoBono_RVRSL.Ultimo_Movimiento__c = objMovimientoBono_RVRSL.Id;
        lstVehiculo.add(objVehiculoBono_RVRSL);
        Database.update(lstVehiculo);
       
        /****************************************** BONO ******************************************/
        //Solicitud de Excepcion Bono
        TAM_DetalleBonos__c objDetalleBonoSeleccionado = [SELECT Id,TAM_BonoTMEXEfectivo__c FROM TAM_DetalleBonos__c WHERE TAM_Serie__c = 'COROLLA' AND TAM_AnioModelo__c = '2020' LIMIT 1];
        TAM_DetalleBonos__c objDetalleBonoCorrespondiente = [SELECT Id,TAM_BonoTMEXEfectivo__c FROM TAM_DetalleBonos__c WHERE TAM_Serie__c = 'COROLLA' AND TAM_AnioModelo__c = '2019' LIMIT 1];
        TAM_TestUtilityClass.crearSolicitudBono(objVehiculoBono_1.Name, 'Aprobado', Date.valueOf(fechaVenta), objDetalleBonoSeleccionado.Id,objDetalleBonoCorrespondiente.Id);
        
        //Estado de Cuenta - Excepcion Bono
		TAM_TestUtilityClass.crearDetalleProvision('Provision Bono Exc', objProvisionAnterior.Id, objVehiculoBono_1.Id, 0, 0, 'Bono',null, 'Sin Reversa');
        TAM_DetalleProvisionIncentivo__c objDetalleBono = [SELECT Id,TAM_BonoTMEX_Efectivo__c FROM TAM_DetalleProvisionIncentivo__c WHERE Name='Provision Bono Exc' AND TAM_VIN__c =:objVehiculoBono_1.Id LIMIT 1];
		
        TAM_TestUtilityClass.crearDetalleEdoCuenta(objVehiculoBono_1.Name, Date.valueOf(fechaVenta), usuarioGuadalajara.CodigoDistribuidor__c, 20000, 'Bono','Pago Autorizado TMEX','Enviado a Facturar','Excepcion', false);        
		TAM_DetalleEstadoCuenta__c objDetalleExcepcionBono = [SELECT Id,TAM_IntercambioEdoCta__c,TAM_RegistroProvisionado__c,TAM_Fecha_Aprobacion_Final__c,TAM_IncentivoPropuestoDealer__c FROM TAM_DetalleEstadoCuenta__c WHERE TAM_VIN__c =: objVehiculoBono_1.Name AND RecordType.Name='Bono' LIMIT 1];
        objDetalleExcepcionBono.TAM_Movimiento__c = 'Excepción';
        objDetalleExcepcionBono.TAM_Estatus_Finanzas__c = 'Pago Autorizado TMEX';
        objDetalleExcepcionBono.TAM_RegistroProvisionado__c = false;
        objDetalleExcepcionBono.TAM_IncentivoPropuestoDealer__c = 5000;
        objDetalleExcepcionBono.TAM_Fecha_Aprobacion_Final__c = Date.valueOf(fechaVenta);
        update objDetalleExcepcionBono; 
        /****************************************** ESTADO DE CUENTA ******************************************/
        //Estado de Cuenta - VIN Facturado/Transmitido
        TAM_TestUtilityClass.crearDetalleEdoCuenta(objVehiculoRetail_1.Name, Date.valueOf(fechaVenta), usuarioGuadalajara.CodigoDistribuidor__c, 20000, 'Retail','Pago Autorizado TMEX','Enviado a Facturar', 'RVRSL',false);        
        
        /*Reversa*/

        TAM_TestUtilityClass.crearDetalleEdoCuenta(objVehiculoBono_RVRSL.Name, Date.valueOf(fechaVenta2), usuarioGuadalajara.CodigoDistribuidor__c, 20000, 'Bono','Pago Autorizado TMEX','Enviado a Facturar','RDR', false);        
        
        Id jobID_Bono = TAM_NewProvisionControllerClass.executeBatchJob_Bonos(objProvision.Id);
        AsyncApexJob jobInfo_Bono = TAM_NewProvisionControllerClass.getBatchJobStatus_Bonos(jobID_Bono);
        Test.stopTest();
        System.assertEquals(0, jobInfo_Bono.NumberOfErrors);
    }
    
	//Prueba Excepción Retail
	@isTest
    public static void provisionBatchRetail_Excepciones(){
        Test.startTest();
        DateTime fechaVenta = DateTime.now();
        String month = String.valueOf(fechaVenta.month());
        String year = String.valueOf(fechaVenta.year());
        User usuarioGuadalajara = [SELECT Id,CodigoDistribuidor__c FROM User WHERE CodigoDistribuidor__c = '57011' LIMIT 1];
        TAM_ProvisionIncentivos__c objProvision = [SELECT Id FROM TAM_ProvisionIncentivos__c WHERE Name = 'Provision Prueba' LIMIT 1];
        TAM_ProvisionIncentivos__c objProvisionAnterior = [SELECT Id,TAM_MesDeProvision__c, TAM_AnioDeProvision__c FROM TAM_ProvisionIncentivos__c WHERE Name = 'Provision Prueba Anterior' LIMIT 1];
        Account acc = [SELECT Id FROM Account WHERE Name='Gerente Guadalajara' LIMIT 1];
        
		//Productos
        Product2 objProducto_COROLLA_1780020 = [SELECT Id FROM Product2 WHERE Name= '1780' LIMIT 1];
        
        //Politica Incentivos Retail
        TAM_PoliticasIncentivos__c objPoliticaRetail = [SELECT Id FROM TAM_PoliticasIncentivos__c WHERE Name='Politica_Retail'];
        TAM_DetallePoliticaJunction__c objDetallePolitica_Retail_05 = [SELECT id FROM TAM_DetallePoliticaJunction__c WHERE TAM_Clave__c='1780' LIMIT 1]; 

		//Vehiculos
        /*Prueba Excepción*/	Vehiculo__c objVehiculoRetail_ExcepcionIncentivo = TAM_TestUtilityClass.crearVIN('ETMR13FV1LD061620', '2020');
        						Database.insert(objVehiculoRetail_ExcepcionIncentivo);
		
        /*Excepcion incentivo*/
        Movimiento__c objMovimientoRetail = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '4', fechaVenta, 'N',month, year, objProducto_COROLLA_1780020.Id, objVehiculoRetail_ExcepcionIncentivo.Id, acc.Id);
        Database.insert(objMovimientoRetail);
        objVehiculoRetail_ExcepcionIncentivo.Ultimo_Movimiento__c = objMovimientoRetail.id;
        Database.update(objVehiculoRetail_ExcepcionIncentivo);
        
        //EXCEPCIONES RETAIL
        String retail = objPoliticaRetail.Id;
        TAM_DetallePoliticaJunction__c objDetalle = [SELECT Id FROM TAM_DetallePoliticaJunction__c WHERE TAM_Serie__c = 'COROLLA' AND TAM_PoliticaIncentivos__c =:retail  LIMIT 1];
        TAM_TestUtilityClass.solicitudExcepcionIncentivo('Excepción de Incentivo',objVehiculoRetail_ExcepcionIncentivo.Name, objDetalle.Id, 'Aprobado', Date.valueOf(fechaVenta));
        TAM_TestUtilityClass.crearDetalleEdoCuenta(objVehiculoRetail_ExcepcionIncentivo.Name, Date.valueOf(fechaVenta), usuarioGuadalajara.CodigoDistribuidor__c, 20000, 'Retail','Pago Autorizado TMEX','Enviado a Facturar','Excepcion', false);        
		TAM_DetalleEstadoCuenta__c objDetalleExcepcion = [SELECT Id,TAM_Movimiento__c,TAM_Estatus_Finanzas__c,TAM_IntercambioEdoCta__c FROM TAM_DetalleEstadoCuenta__c WHERE TAM_VIN__c =:objVehiculoRetail_ExcepcionIncentivo.Name LIMIT 1];
        objDetalleExcepcion.TAM_Movimiento__c = 'Excepción';
        objDetalleExcepcion.TAM_Estatus_Finanzas__c = 'Pago Autorizado TMEX';
        update objDetalleExcepcion;
        
        //Estado de cuenta - Transferencia de Venta corporativa a Retail
        Vehiculo__c objVehiculoRetail_00 = TAM_TestUtilityClass.crearVIN('JTDKDTB33M1143100', '2020');
        TAM_TestUtilityClass.crearDetalleProvision('Detalle Retail Transferido', objProvisionAnterior.Id, objVehiculoRetail_00.Id, 10000, 5000, 'Venta Corporativa',null, 'Sin Reversa');
        TAM_DetalleProvisionIncentivo__c objDetalleRetail = [SELECT Id,TAM_IncentivoTMEX_Efectivo__c FROM TAM_DetalleProvisionIncentivo__c WHERE Name='Detalle Retail Transferido' AND TAM_VIN__c =:objVehiculoRetail_00.Id LIMIT 1];
        
        TAM_TestUtilityClass.crearDetalleEdoCuenta(objVehiculoRetail_00.Name, Date.valueOf(fechaVenta).addMonths(-1), usuarioGuadalajara.CodigoDistribuidor__c, 20000, 'Flotilla','Pago Autorizado TMEX','Enviado a Facturar', 'RDR',true);        
        
        TAM_DetalleEstadoCuenta__c objDetalleTransmitidoRetail = [SELECT Id, TAM_DetalleProvision__c,TAM_IntercambioEdoCta__c FROM TAM_DetalleEstadoCuenta__c WHERE TAM_IntercambioEdoCta__c = true AND TAM_VIN__c =: objVehiculoRetail_00.Name LIMIT 1];
        objDetalleTransmitidoRetail.TAM_DetalleProvision__c = objDetalleRetail.Id;
        update objDetalleTransmitidoRetail;
        
        //Proceso Batch        
		Id jobID = TAM_NewProvisionControllerClass.executeBatchJob(objProvision.Id);
        AsyncApexJob jobInfo = TAM_NewProvisionControllerClass.getBatchJobStatus(jobID);
        Test.stopTest();
        System.assertEquals(0, jobInfo.NumberOfErrors);
    }
    
	//Prueba Excepción VC
	@isTest
    public static void provisionExcepcionesControllerClass_VentaCorporativa(){
        Test.startTest();
        DateTime fechaVenta = DateTime.now();
        String month = String.valueOf(fechaVenta.month());
        String year = String.valueOf(fechaVenta.year());
        Id RecordTypeId_Excepcion = Schema.SObjectType.TAM_DetalleProvisionIncentivo__c.getRecordTypeInfosByName().get('Excepcion').getRecordTypeId();
        TAM_ProvisionIncentivos__c objProvision = [SELECT Id FROM TAM_ProvisionIncentivos__c WHERE Name = 'Provision Prueba' LIMIT 1];
        
        //Política de incentivos
        TAM_PoliticasIncentivos__c objPoliticaVtaCorp = [SELECT Id FROM TAM_PoliticasIncentivos__c WHERE Name='Politica_VtaCorp'];
		//Vehiculo DOD
        Vehiculo__c objVehiculoVtaCorp_1 = TAM_TestUtilityClass.crearVIN('VTMR13FV1LD061620', '2020');
        Database.insert(objVehiculoVtaCorp_1);
        Product2 objProducto_RAV4_45012020 = [SELECT Id FROM Product2 WHERE ProductCode='45012020'];
        Account acc = [SELECT Id FROM Account WHERE Name='Gerente Guadalajara' LIMIT 1];
        Movimiento__c objMovimiento1 = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '4', fechaVenta, 'N',month, year, objProducto_RAV4_45012020.id, objVehiculoVtaCorp_1.Id, acc.id);
        Database.insert(objMovimiento1);
        objVehiculoVtaCorp_1.Ultimo_Movimiento__c = objMovimiento1.Id;
        update objVehiculoVtaCorp_1;      
        
        TAM_TestUtilityClass.crearDetalleProvision('DetalleProvisionBono_06', objProvision.Id,objVehiculoVtaCorp_1.Id, 50000, 0, 'Excepcion',objPoliticaVtaCorp.Id, 'Excepción Venta Corporativa');
        
        List<TAM_DetalleProvisionIncentivo__c> lstDetalleProvision = [SELECT Name, TAM_FechaEnvio__c, TAM_FechaVenta__c,TAM_ProvisionIncentivos__c,TAM_VIN__c,RecordTypeId,TAM_PoliticaIncentivos__c,
                                                                      TAM_PoliticaIncentivos__r.Id,
                                                                      TAM_PoliticaIncentivos__r.Name,
                                                                      TAM_PoliticaIncentivos__r.TAM_FinVigencia__c
                                                                      FROM TAM_DetalleProvisionIncentivo__c
                                                                      WHERE RecordTypeId =:RecordTypeId_Excepcion
                                                                      AND TAM_Clasificacion__c = 'Excepción Venta Corporativa'];
        List<TAM_DetalleProvisionIncentivo__c> lstDetalle = TAM_ProvisionExcepcionesControllerClass.getExcepcionesVtaCorp(objProvision.Id);
        TAM_ProvisionExcepcionesControllerClass.setRecordExcepcionVentaCorp(lstDetalleProvision, objProvision.Id);
        TAM_ProvisionExcepcionesControllerClass.cerrarProvisionExcepcionVentaCorp(lstDetalleProvision, objProvision.Id);
        Test.stopTest();
        System.assert(lstDetalle.size() > 0);
    }
	
	//Prueba Excepción Bono
	@isTest
    public static void provisionExcepcionesControllerClass_Bonos(){
        Test.startTest();
        Product2 objProducto_RAV4_45012020 = [SELECT Id FROM Product2 WHERE Name= '4501' LIMIT 1];
        User usuarioGuadalajara = [SELECT Id,CodigoDistribuidor__c FROM User WHERE CodigoDistribuidor__c = '57011' LIMIT 1];
        TAM_ProvisionIncentivos__c objProvision = [SELECT Id FROM TAM_ProvisionIncentivos__c WHERE Name = 'Provision Prueba' LIMIT 1];
        Account acc = [SELECT Id FROM Account WHERE Name='Gerente Guadalajara' LIMIT 1];
        DateTime fechaVenta = DateTime.now();
        String month = String.valueOf(fechaVenta.month());
        String year = String.valueOf(fechaVenta.year());
        Id RecordTypeId_Excepcion = Schema.SObjectType.TAM_DetalleProvisionIncentivo__c.getRecordTypeInfosByName().get('Excepcion').getRecordTypeId();
        TAM_PoliticasIncentivos__c objPoliticaRetail = [SELECT Id FROM TAM_PoliticasIncentivos__c WHERE Name='Politica_Retail'];
        Vehiculo__c objVehiculoBono = TAM_TestUtilityClass.crearVIN('JTDKDTB38M1142683', '2020');
       	Database.insert(objVehiculoBono);
        Movimiento__c objMovimiento = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '4', fechaVenta, 'N',month, year, objProducto_RAV4_45012020.Id, objVehiculoBono.Id, acc.Id);
        Database.insert(objMovimiento);
        
        //Estado de Cuenta - Excepcion Bono
        TAM_TestUtilityClass.crearDetalleEdoCuenta(objVehiculoBono.Name, Date.valueOf(fechaVenta).addMonths(-1), usuarioGuadalajara.CodigoDistribuidor__c, 20000, 'Bono','Pago Autorizado TMEX','Enviado a Facturar','Excepcion', false);        
        TAM_TestUtilityClass.crearDetalleProvision('DetalleProvisionBono_05', objProvision.Id,objVehiculoBono.Id, 0, 50000, 'Excepcion',objPoliticaRetail.Id, 'Excepción Bono');

        //Estado de Cuenta - Excepcion Bono
        TAM_TestUtilityClass.crearDetalleEdoCuenta(objVehiculoBono.Name, Date.valueOf(fechaVenta).addMonths(-1), usuarioGuadalajara.CodigoDistribuidor__c, 20000, 'Bono','Pago Autorizado TMEX','Enviado a Facturar','Excepcion', false);        
        List<TAM_DetalleProvisionIncentivo__c> lstDetalleProvision = [SELECT Name, TAM_FechaEnvio__c, TAM_FechaVenta__c,TAM_ProvisionIncentivos__c,TAM_VIN__c,RecordTypeId,TAM_PoliticaIncentivos__c,
                                                                      TAM_PoliticaIncentivos__r.Id,
                                                                      TAM_PoliticaIncentivos__r.Name,
                                                                      TAM_PoliticaIncentivos__r.TAM_FinVigencia__c,
                                                                      TAM_BonoTMEX_Efectivo__c
                                                                      FROM TAM_DetalleProvisionIncentivo__c
                                                                      WHERE RecordTypeId =:RecordTypeId_Excepcion
                                                                      AND TAM_Clasificacion__c = 'Excepción Bono'];
        
        List<TAM_DetalleProvisionIncentivo__c> lstDetalle = TAM_ProvisionExcepcionesControllerClass.getExcepcionesBonos(objProvision.Id);
        TAM_ProvisionExcepcionesControllerClass.setRecordExcepcionBono(lstDetalleProvision, objProvision.Id);
        TAM_ProvisionExcepcionesControllerClass.cerrarProvisionExcepcionBono(lstDetalleProvision, objProvision.Id);
        Test.stopTest();
        System.assert(lstDetalle.size() > 0);
    }
	
	//Prueba Analisis de Reversas Retail
	@isTest
    public static void provisionBatchRetail_ConReversa(){
        Test.startTest();
        DateTime fechaVenta = DateTime.now();
        DateTime fechaVenta2 = DateTime.now().addDays(-70);
        String month = String.valueOf(fechaVenta.month());
        String year = String.valueOf(fechaVenta.year());
        String month2 = String.valueOf(fechaVenta2.month());
        String year2 = String.valueOf(fechaVenta2.year());
        List<Movimiento__c> lstMovimientos = new List<Movimiento__c>();
        User usuarioGuadalajara = [SELECT Id,CodigoDistribuidor__c FROM User WHERE CodigoDistribuidor__c = '57011' LIMIT 1];
        TAM_ProvisionIncentivos__c objProvision = [SELECT Id FROM TAM_ProvisionIncentivos__c WHERE Name = 'Provision Prueba' LIMIT 1];
        TAM_ProvisionIncentivos__c objProvisionAnterior = [SELECT Id,TAM_MesDeProvision__c, TAM_AnioDeProvision__c FROM TAM_ProvisionIncentivos__c WHERE Name = 'Provision Prueba Anterior' LIMIT 1];
        Account acc = [SELECT Id FROM Account WHERE Name='Gerente Guadalajara' LIMIT 1];
        
		//Productos
        Product2 objProducto_COROLLA_1780020 = [SELECT Id FROM Product2 WHERE Name= '1780' LIMIT 1];
        
        //Politica Incentivos Retail
        TAM_PoliticasIncentivos__c objPoliticaRetail = [SELECT Id FROM TAM_PoliticasIncentivos__c WHERE Name='Politica_Retail'];
        TAM_DetallePoliticaJunction__c objDetallePolitica_Retail_05 = [SELECT id FROM TAM_DetallePoliticaJunction__c WHERE TAM_Clave__c='1780' LIMIT 1]; 

		//Vehiculos
        /*Prueba Reversa*/	Vehiculo__c objVehiculoRetail = TAM_TestUtilityClass.crearVIN('JTDKDTB38M1142686', '2020');
        					Database.insert(objVehiculoRetail);
		
        /*Reversa*/
        Movimiento__c objMovimientoRetail1 = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '1', fechaVenta2, 'N',month2, year2, objProducto_COROLLA_1780020.Id, objVehiculoRetail.Id, acc.Id);
        Movimiento__c objMovimientoRetail2 = TAM_TestUtilityClass.crearMovimientos('2020','RVRSL', '1', fechaVenta, 'N',month, year, objProducto_COROLLA_1780020.Id, objVehiculoRetail.Id, acc.Id);
        lstMovimientos.add(objMovimientoRetail1);
        lstMovimientos.add(objMovimientoRetail2);
        Database.insert(lstMovimientos);
        
        //Último movimiento
        objVehiculoRetail.Ultimo_Movimiento__c = objMovimientoRetail2.Id;
        Database.update(objVehiculoRetail);
        
		/*Estado de Cuenta*/
        TAM_TestUtilityClass.crearDetalleEdoCuenta(objVehiculoRetail.Name, Date.valueOf(fechaVenta2), usuarioGuadalajara.CodigoDistribuidor__c, 20000, 'Retail','Pago Autorizado TMEX','Enviado a Facturar','RDR', false);        

        //Proceso Batch        
		Id jobID = TAM_NewProvisionControllerClass.executeBatchJob(objProvision.Id);
        AsyncApexJob jobInfo = TAM_NewProvisionControllerClass.getBatchJobStatus(jobID);
        Test.stopTest();
        System.assertEquals(0, jobInfo.NumberOfErrors);
    }
    
    
	//Prueba Provisión de Reversas
	
	//Prueba Provisión Incentivos Class
    @isTest
    public static void provisionIncentivosClass(){
        TAM_ProvisionIncentivos__c objProvision = [SELECT Id, TAM_MesDeProvision__c FROM TAM_ProvisionIncentivos__c WHERE Name = 'Provision Prueba' LIMIT 1];
        Test.startTest();
        TAM_ProvisionIncentivos__c objProvision_Return = TAM_ProvicionIncentivosClass.getProvisionInfo(objProvision.Id);
        Test.stopTest();
        System.assertEquals(objProvision.TAM_MesDeProvision__c, objProvision_Return.TAM_MesDeProvision__c);
    }
    
    //Prueba Retail Controller
    @isTest
    public static void provisionRetailControllerClass(){
        Id RecordTypeId_Retail = Schema.SObjectType.TAM_DetalleProvisionIncentivo__c.getRecordTypeInfosByName().get('Retail').getRecordTypeId();
        TAM_ProvisionIncentivos__c objProvision = [SELECT Id FROM TAM_ProvisionIncentivos__c WHERE Name = 'Provision Prueba' LIMIT 1];
        Vehiculo__c objVehiculoRetail_1 = TAM_TestUtilityClass.crearVIN('JTDKDTB33M1143188', '2020');
        Database.insert(objVehiculoRetail_1);
        TAM_PoliticasIncentivos__c objPoliticaRetail = [SELECT Id FROM TAM_PoliticasIncentivos__c WHERE Name='Politica_Retail'];
        TAM_TestUtilityClass.crearDetalleProvision('DetalleProvisionBono_02', objProvision.Id,objVehiculoRetail_1.Id, 50000, 0, 'Retail', objPoliticaRetail.Id, 'Sin Reversa');
       
        List<TAM_DetalleProvisionIncentivo__c> lstDetalleProvision = [SELECT Name, TAM_FechaEnvio__c, TAM_FechaVenta__c,TAM_ProvisionIncentivos__c,TAM_VIN__c,RecordTypeId,TAM_PoliticaIncentivos__c,
                                                                      TAM_PoliticaIncentivos__r.Id,
                                                                      TAM_PoliticaIncentivos__r.Name,
                                                                      TAM_PoliticaIncentivos__r.TAM_FinVigencia__c
                                                                      FROM TAM_DetalleProvisionIncentivo__c
                                                                      WHERE RecordTypeId =:RecordTypeId_Retail
                                                                      AND TAM_Clasificacion__c = 'Sin Reversa'];
        Test.startTest();
        List<TAM_DetalleProvisionIncentivo__c> lstDetalle = TAM_ProvisionRetailControllerClass.getRetailSinReversa(objProvision.Id);
        TAM_ProvisionRetailControllerClass.setRecordsRetail(lstDetalleProvision, objProvision.Id);
        TAM_ProvisionRetailControllerClass.cerrarProvision(lstDetalleProvision, objProvision.Id);
        Test.stopTest();
        System.assert(lstDetalle.size() > 0);
    }
    
    //Prueba de controller para Excepciones
    @isTest
    public static void provisionExcepcionesControllerClass(){
        Id RecordTypeId_Excepcion = Schema.SObjectType.TAM_DetalleProvisionIncentivo__c.getRecordTypeInfosByName().get('Excepcion').getRecordTypeId();
        TAM_ProvisionIncentivos__c objProvision = [SELECT Id FROM TAM_ProvisionIncentivos__c WHERE Name = 'Provision Prueba' LIMIT 1];
        Vehiculo__c objVehiculoRetail_ExcepcionIncentivo = TAM_TestUtilityClass.crearVIN('ETMR13FV1LD061620', '2020');
        Database.insert(objVehiculoRetail_ExcepcionIncentivo);
        TAM_PoliticasIncentivos__c objPoliticaRetail = [SELECT Id FROM TAM_PoliticasIncentivos__c WHERE Name='Politica_Retail'];
        
        TAM_TestUtilityClass.crearDetalleProvision('DetalleProvisionBono_04', objProvision.Id,objVehiculoRetail_ExcepcionIncentivo.Id, 50000, 0, 'Excepcion', objPoliticaRetail.Id, 'Excepción Retail');
        List<TAM_DetalleProvisionIncentivo__c> lstDetalleProvision = [SELECT Name, TAM_FechaEnvio__c, TAM_FechaVenta__c,TAM_ProvisionIncentivos__c,TAM_VIN__c,RecordTypeId,TAM_PoliticaIncentivos__c,
                                                                      TAM_PoliticaIncentivos__r.Id,
                                                                      TAM_PoliticaIncentivos__r.Name,
                                                                      TAM_PoliticaIncentivos__r.TAM_FinVigencia__c
                                                                      FROM TAM_DetalleProvisionIncentivo__c
                                                                      WHERE RecordTypeId =:RecordTypeId_Excepcion
                                                                      AND TAM_Clasificacion__c = 'Excepción Retail'];
        Test.startTest();
        List<TAM_DetalleProvisionIncentivo__c> lstDetalle = TAM_ProvisionExcepcionesControllerClass.getExcepcionesRetail(objProvision.Id);
        TAM_ProvisionExcepcionesControllerClass.setRecordExcepcionRetail(lstDetalleProvision, objProvision.Id);
        TAM_ProvisionExcepcionesControllerClass.cerrarProvisionExcepcionRetail(lstDetalleProvision, objProvision.Id);
        Test.stopTest();
        System.assert(lstDetalle.size() > 0);
    }
	
    //Prueba para el controller de Auto Demo
    @isTest
    public static void provisionAutoDemoControllerClass(){
        Id RecordTypeId_Demo = Schema.SObjectType.TAM_DetalleProvisionIncentivo__c.getRecordTypeInfosByName().get('AutoDemo').getRecordTypeId();
        TAM_ProvisionIncentivos__c objProvision = [SELECT Id FROM TAM_ProvisionIncentivos__c WHERE Name = 'Provision Prueba' LIMIT 1];
        Vehiculo__c objVehiculoDemo_1 = TAM_TestUtilityClass.crearVIN('ATMR13FV1LD061622', '2020');
        Database.insert(objVehiculoDemo_1);
        TAM_PoliticasIncentivos__c objPoliticaRetail = [SELECT Id FROM TAM_PoliticasIncentivos__c WHERE Name='Politica_Retail'];
        TAM_TestUtilityClass.crearDetalleProvision('DetalleProvisionBono_09', objProvision.Id,objVehiculoDemo_1.Id, 50000, 0, 'AutoDemo', objPoliticaRetail.Id, 'Sin Reversa');
        
        List<TAM_DetalleProvisionIncentivo__c> lstDetalleProvision = [SELECT Name, TAM_FechaEnvio__c, TAM_FechaVenta__c,TAM_ProvisionIncentivos__c,TAM_VIN__c,RecordTypeId,TAM_PoliticaIncentivos__c,
                                                                      TAM_PoliticaIncentivos__r.Id,
                                                                      TAM_PoliticaIncentivos__r.Name,
                                                                      TAM_PoliticaIncentivos__r.TAM_FinVigencia__c
                                                                      FROM TAM_DetalleProvisionIncentivo__c
                                                                      WHERE RecordTypeId =:RecordTypeId_Demo];
        Test.startTest();
        List<TAM_DetalleProvisionIncentivo__c> lstDetalle = TAM_ProvisionDemoControllerClass.getAutosDemo(objProvision.Id);
        TAM_ProvisionDemoControllerClass.setRecordAutoDemo(lstDetalleProvision, objProvision.Id);
        TAM_ProvisionDemoControllerClass.cerrarProvisionAutoDemo(lstDetalleProvision, objProvision.Id);
        Test.stopTest();
        System.assert(lstDetalle.size() > 0);
    }
    
    //Prueba para el controller de Bonos
    @isTest
    public static void provisionBonoControllerClass(){
        TAM_ProvisionIncentivos__c objProvision = [SELECT Id FROM TAM_ProvisionIncentivos__c WHERE Name = 'Provision Prueba' LIMIT 1];
        Id RecordTypeId_Bono = Schema.SObjectType.TAM_DetalleProvisionIncentivo__c.getRecordTypeInfosByName().get('Bono').getRecordTypeId();
        Vehiculo__c objVehiculoRetail_1 = TAM_TestUtilityClass.crearVIN('JTDKDTB33M1143188', '2020');
        Database.insert(objVehiculoRetail_1);
        TAM_PoliticasIncentivos__c objPoliticaRetail = [SELECT Id FROM TAM_PoliticasIncentivos__c WHERE Name='Politica_Retail'];
        TAM_TestUtilityClass.crearDetalleProvision('DetalleProvisionBono_01', objProvision.Id,objVehiculoRetail_1.Id, 0, 50000, 'Bono',objPoliticaRetail.Id, 'Sin Reversa');

        List<TAM_DetalleProvisionIncentivo__c> lstDetalleProvision = [SELECT Name, TAM_FechaEnvio__c, TAM_FechaVenta__c,TAM_ProvisionIncentivos__c,TAM_VIN__c,RecordTypeId
                                                                      FROM TAM_DetalleProvisionIncentivo__c
                                                                      WHERE RecordTypeId =:RecordTypeId_Bono
                                                                      AND TAM_Clasificacion__c = 'Sin Reversa'];
        Test.startTest();
        List<TAM_DetalleProvisionIncentivo__c> lstDetalle = TAM_ProvisionBonoControllerClass.getBonos(objProvision.Id);
        TAM_ProvisionBonoControllerClass.setRecordsBonos(lstDetalleProvision, objProvision.Id);
        TAM_ProvisionBonoControllerClass.cerrarProvision(lstDetalleProvision, objProvision.Id);
        Test.stopTest();
        System.assert(lstDetalle.size() > 0);
    }
    
    //Prueba para el controller de Reversas Analisis y Pendientes
    @isTest
    public static void provisionReversasControllerClass(){
        TAM_ProvisionIncentivos__c objProvision = [SELECT Id FROM TAM_ProvisionIncentivos__c WHERE Name = 'Provision Prueba' LIMIT 1];
        TAM_PoliticasIncentivos__c objPoliticaRetail = [SELECT Id FROM TAM_PoliticasIncentivos__c WHERE Name='Politica_Retail'];
        Vehiculo__c objVehiculoRetail_2 = TAM_TestUtilityClass.crearVIN('JTDKDTB38M1142683', '2020');
        Database.insert(objVehiculoRetail_2);
        TAM_TestUtilityClass.crearDetalleProvision('DetalleProvisionBono_03', objProvision.Id, objVehiculoRetail_2.Id, 50000, 0, 'Retail', objPoliticaRetail.Id, 'Con Reversa');
        List<TAM_DetalleProvisionIncentivo__c> lstDetalleProvision = [SELECT Name, TAM_FechaEnvio__c, TAM_FechaVenta__c,TAM_ProvisionIncentivos__c,TAM_VIN__c,RecordTypeId,TAM_PoliticaIncentivos__c,
                                                                      TAM_PoliticaIncentivos__r.Id,
                                                                      TAM_PoliticaIncentivos__r.Name,
                                                                      TAM_PoliticaIncentivos__r.TAM_FinVigencia__c
                                                                      FROM TAM_DetalleProvisionIncentivo__c
                                                                      WHERE TAM_Clasificacion__c = 'Con Reversa'];
        
        Test.startTest();
        List<TAM_DetalleProvisionIncentivo__c> lstDetalleAnalisis = TAM_ProvisionReversasControllerClass.getReversa(objProvision.Id);
        TAM_ProvisionReversasControllerClass.setRecordsReversas(lstDetalleProvision, objProvision.Id);
        TAM_ProvisionReversasControllerClass.cerrarProvision(lstDetalleProvision, objProvision.Id);
        
        List<TAM_DetalleProvisionIncentivo__c> lstDetalleProvision_AUX = new List<TAM_DetalleProvisionIncentivo__c>();
        for(TAM_DetalleProvisionIncentivo__c objDetalle : lstDetalleProvision){
            objDetalle.TAM_ReversaPendienteProvision__c = true;
            lstDetalleProvision_AUX.add(objDetalle);
        }
        upsert lstDetalleProvision_AUX;
        List<TAM_DetalleProvisionIncentivo__c> lstDetallePendientes = TAM_ProvisionReversasControllerClass.getPendientes(objProvision.Id);
        
        TAM_ProvisionReversasControllerClass.setRecordsPendientes(lstDetalleProvision_AUX, objProvision.Id);
        TAM_ProvisionReversasControllerClass.cerrarProvisionPendientes(lstDetalleProvision_AUX, objProvision.Id);
        Test.stopTest();
        System.assert(lstDetalleAnalisis.size() > 0);
        System.assert(lstDetallePendientes.size() > 0);
    }
    
    //Prueba controller Transferidos de VC a Retail
     @isTest
    public static void provisionExcepcionesControllerClass_Transferido(){
        Test.startTest();
        DateTime fechaVenta = DateTime.now();
        String month = String.valueOf(fechaVenta.month());
        String year = String.valueOf(fechaVenta.year());
        Vehiculo__c objVehiculoVtaCorp_1 = TAM_TestUtilityClass.crearVIN('VTMR13FV1LD061620', '2020');
        Database.insert(objVehiculoVtaCorp_1);
        Product2 objProducto_RAV4_45012020 = [SELECT Id FROM Product2 WHERE ProductCode='45012020'];
        Account acc = [SELECT Id FROM Account WHERE Name='Gerente Guadalajara' LIMIT 1];
        Movimiento__c objMovimiento1 = TAM_TestUtilityClass.crearMovimientos('2020','RDR', '4', fechaVenta, 'N',month, year, objProducto_RAV4_45012020.id, objVehiculoVtaCorp_1.Id, acc.id);
        Database.insert(objMovimiento1);
        objVehiculoVtaCorp_1.Ultimo_Movimiento__c = objMovimiento1.Id;
        update objVehiculoVtaCorp_1;   
        
        TAM_PoliticasIncentivos__c objPoliticaRetail = [SELECT Id FROM TAM_PoliticasIncentivos__c WHERE Name='Politica_Retail'];
        Id RecordTypeId_Excepcion = Schema.SObjectType.TAM_DetalleProvisionIncentivo__c.getRecordTypeInfosByName().get('Excepcion').getRecordTypeId();
        TAM_ProvisionIncentivos__c objProvision = [SELECT Id FROM TAM_ProvisionIncentivos__c WHERE Name = 'Provision Prueba' LIMIT 1];
        TAM_TestUtilityClass.crearDetalleProvision('DetalleProvisionBono_07', objProvision.Id,objVehiculoVtaCorp_1.Id, 50000, 0, 'Excepcion',objPoliticaRetail.Id, 'Transferido Vta.Corp. a Retail');
        
        List<TAM_DetalleProvisionIncentivo__c> lstDetalleProvision = [SELECT Name, TAM_FechaEnvio__c, TAM_FechaVenta__c,TAM_ProvisionIncentivos__c,TAM_VIN__c,RecordTypeId,TAM_PoliticaIncentivos__c,
                                                                      TAM_PoliticaIncentivos__r.Id,
                                                                      TAM_PoliticaIncentivos__r.Name,
                                                                      TAM_PoliticaIncentivos__r.TAM_FinVigencia__c
                                                                      FROM TAM_DetalleProvisionIncentivo__c
                                                                      WHERE RecordTypeId =:RecordTypeId_Excepcion
                                                                      AND TAM_Clasificacion__c = 'Transferido Vta.Corp. a Retail'];
        List<TAM_DetalleProvisionIncentivo__c> lstDetalle = TAM_ProvisionExcepcionesControllerClass.getTransferidos(objProvision.Id);
        TAM_ProvisionExcepcionesControllerClass.setRecordTransferidos(lstDetalleProvision, objProvision.Id);
        TAM_ProvisionExcepcionesControllerClass.cerrarProvisionTransferidos(lstDetalleProvision, objProvision.Id);
        Test.stopTest();
        System.assert(lstDetalle.size() > 0);
    }
    
    //Prueba Controller VC
    @isTest
    public static void provisionVentaCorpControllerClass(){
        Id RecordTypeId_VtaCorp = Schema.SObjectType.TAM_DetalleProvisionIncentivo__c.getRecordTypeInfosByName().get('Venta Corporativa').getRecordTypeId();
        TAM_ProvisionIncentivos__c objProvision = [SELECT Id FROM TAM_ProvisionIncentivos__c WHERE Name = 'Provision Prueba' LIMIT 1];
        Vehiculo__c objVehiculoRetail_1 = TAM_TestUtilityClass.crearVIN('JTDKDTB33M1143188', '2020');
        Database.insert(objVehiculoRetail_1);
        TAM_PoliticasIncentivos__c objPoliticaVtaCorp = [SELECT Id FROM TAM_PoliticasIncentivos__c WHERE Name='Politica_VtaCorp'];
        TAM_TestUtilityClass.crearDetalleProvision('DetalleProvisionBono_08', objProvision.Id,objVehiculoRetail_1.Id, 50000, 0, 'Venta Corporativa', objPoliticaVtaCorp.Id, 'Sin Reversa');
        List<TAM_DetalleProvisionIncentivo__c> lstDetalleProvision = [SELECT Name, TAM_FechaEnvio__c, TAM_FechaVenta__c,TAM_ProvisionIncentivos__c,TAM_VIN__c,RecordTypeId,TAM_PoliticaIncentivos__c,
                                                                      TAM_PoliticaIncentivos__r.Id,
                                                                      TAM_PoliticaIncentivos__r.Name,
                                                                      TAM_PoliticaIncentivos__r.TAM_FinVigencia__c,TAM_FinVigPoliticaRetail_AUX__c
                                                                      FROM TAM_DetalleProvisionIncentivo__c
                                                                      WHERE RecordTypeId =:RecordTypeId_VtaCorp];
        Test.startTest();
        List<TAM_DetalleProvisionIncentivo__c> lstDetalle = TAM_ProvisionIncentivosVentaCorporCtrl.getRetailFlotilla(objProvision.Id);
        TAM_ProvisionIncentivosVentaCorporCtrl.saveProvision(objProvision.Id,  lstDetalleProvision);
        TAM_ProvisionIncentivosVentaCorporCtrl.saveCerrarProvision(objProvision.Id,  lstDetalleProvision);
        Test.stopTest();
        System.assert(lstDetalle.size() > 0);
    }
}